Index: drivers/filesystems/btrfs/pnp.c
===================================================================
--- drivers/filesystems/btrfs/pnp.c	(révision 74430)
+++ drivers/filesystems/btrfs/pnp.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -38,6 +38,8 @@
     pnp_stripe* stripe = conptr;
     pnp_context* context = (pnp_context*)stripe->context;
     
+    UNUSED(DeviceObject);
+    
     stripe->Status = Irp->IoStatus.Status;
     
     InterlockedDecrement(&context->left);
@@ -49,33 +51,26 @@
 }
 
 static NTSTATUS send_disks_pnp_message(device_extension* Vcb, UCHAR minor) {
-    pnp_context* context;
+    pnp_context context;
     UINT64 num_devices, i;
     NTSTATUS Status;
     LIST_ENTRY* le;
     
-    context = ExAllocatePoolWithTag(NonPagedPool, sizeof(pnp_context), ALLOC_TAG);
-    if (!context) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     
-    RtlZeroMemory(context, sizeof(pnp_context));
-    KeInitializeEvent(&context->Event, NotificationEvent, FALSE);
+    RtlZeroMemory(&context, sizeof(pnp_context));
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
     
     num_devices = Vcb->superblock.num_devices;
     
-    context->stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(pnp_stripe) * num_devices, ALLOC_TAG);
-    if (!context->stripes) {
+    context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(pnp_stripe) * num_devices, ALLOC_TAG);
+    if (!context.stripes) {
         ERR("out of memory\n");
-        ExFreePool(context);
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end2;
     }
     
-    RtlZeroMemory(context->stripes, sizeof(pnp_stripe) * num_devices);
+    RtlZeroMemory(context.stripes, sizeof(pnp_stripe) * num_devices);
     
     i = 0;
     le = Vcb->devices.Flink;
@@ -85,75 +80,73 @@
         device* dev = CONTAINING_RECORD(le, device, list_entry);
         
         if (dev->devobj) {
-            context->stripes[i].context = (struct pnp_context*)context;
+            context.stripes[i].context = (struct pnp_context*)&context;
 
-            context->stripes[i].Irp = IoAllocateIrp(dev->devobj->StackSize, FALSE);
+            context.stripes[i].Irp = IoAllocateIrp(dev->devobj->StackSize, FALSE);
             
-            if (!context->stripes[i].Irp) {
+            if (!context.stripes[i].Irp) {
                 UINT64 j;
                 
                 ERR("IoAllocateIrp failed\n");
                 
                 for (j = 0; j < i; j++) {
-                    if (context->stripes[j].dev->devobj) {
-                        IoFreeIrp(context->stripes[j].Irp);
+                    if (context.stripes[j].dev->devobj) {
+                        IoFreeIrp(context.stripes[j].Irp);
                     }
                 }
-                ExFreePool(context->stripes);
-                ExFreePool(context);
+                ExFreePool(context.stripes);
                 
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end2;
             }
             
-            IrpSp = IoGetNextIrpStackLocation(context->stripes[i].Irp);
+            IrpSp = IoGetNextIrpStackLocation(context.stripes[i].Irp);
             IrpSp->MajorFunction = IRP_MJ_PNP;
             IrpSp->MinorFunction = minor;
 
-            context->stripes[i].Irp->UserIosb = &context->stripes[i].iosb;
+            context.stripes[i].Irp->UserIosb = &context.stripes[i].iosb;
             
-            IoSetCompletionRoutine(context->stripes[i].Irp, pnp_completion, &context->stripes[i], TRUE, TRUE, TRUE);
+            IoSetCompletionRoutine(context.stripes[i].Irp, pnp_completion, &context.stripes[i], TRUE, TRUE, TRUE);
             
-            context->stripes[i].Irp->IoStatus.Status = STATUS_NOT_SUPPORTED;
-            context->stripes[i].dev = dev;
+            context.stripes[i].Irp->IoStatus.Status = STATUS_NOT_SUPPORTED;
+            context.stripes[i].dev = dev;
             
-            context->left++;
+            context.left++;
         }
         
         le = le->Flink;
     }
     
-    if (context->left == 0) {
+    if (context.left == 0) {
         Status = STATUS_SUCCESS;
         goto end;
     }
     
     for (i = 0; i < num_devices; i++) {
-        if (context->stripes[i].Irp) {
-            IoCallDriver(context->stripes[i].dev->devobj, context->stripes[i].Irp);
+        if (context.stripes[i].Irp) {
+            IoCallDriver(context.stripes[i].dev->devobj, context.stripes[i].Irp);
         }
     }
     
-    KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
+    KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
     
     Status = STATUS_SUCCESS;
     
     for (i = 0; i < num_devices; i++) {
-        if (context->stripes[i].Irp) {
-            if (context->stripes[i].Status != STATUS_SUCCESS)
-                Status = context->stripes[i].Status;
+        if (context.stripes[i].Irp) {
+            if (context.stripes[i].Status != STATUS_SUCCESS)
+                Status = context.stripes[i].Status;
         }
     }
     
 end:
     for (i = 0; i < num_devices; i++) {
-        if (context->stripes[i].Irp) {
-            IoFreeIrp(context->stripes[i].Irp);
+        if (context.stripes[i].Irp) {
+            IoFreeIrp(context.stripes[i].Irp);
         }
     }
 
-    ExFreePool(context->stripes);
-    ExFreePool(context);
+    ExFreePool(context.stripes);
     
 end2:
     ExReleaseResourceLite(&Vcb->tree_lock);
@@ -161,7 +154,7 @@
     return Status;
 }
 
-static NTSTATUS pnp_cancel_remove_device(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+static NTSTATUS pnp_cancel_remove_device(PDEVICE_OBJECT DeviceObject) {
 device_extension* Vcb = DeviceObject->DeviceExtension;
     NTSTATUS Status;
     
@@ -185,10 +178,9 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS pnp_query_remove_device(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+NTSTATUS pnp_query_remove_device(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     NTSTATUS Status;
-    LIST_ENTRY rollback;
     
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
 
@@ -205,14 +197,19 @@
 
     Vcb->removing = TRUE;
     
-    InitializeListHead(&rollback);
-    
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
 
-    if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, Irp, &rollback);
-    
-    clear_rollback(Vcb, &rollback);
+    if (Vcb->need_write && !Vcb->readonly) {
+        Status = do_write(Vcb, Irp);
+        
+        free_trees(Vcb);
+        
+        if (!NT_SUCCESS(Status)) {
+            ERR("do_write returned %08x\n", Status);
+            ExReleaseResourceLite(&Vcb->tree_lock);
+            goto end;
+        }
+    }
 
     ExReleaseResourceLite(&Vcb->tree_lock);
 
@@ -223,7 +220,7 @@
     return Status;
 }
 
-static NTSTATUS pnp_remove_device(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+static NTSTATUS pnp_remove_device(PDEVICE_OBJECT DeviceObject) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     NTSTATUS Status;
     
@@ -233,15 +230,20 @@
     }
     
     if (DeviceObject->Vpb->Flags & VPB_MOUNTED) {
+        volume_device_extension* vde;
+        
         Status = FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_DISMOUNT);
         if (!NT_SUCCESS(Status)) {
             WARN("FsRtlNotifyVolumeEvent returned %08x\n", Status);
         }
         
-        if (Vcb->open_files > 0) {
-            Vcb->removing = TRUE;
-            Vcb->Vpb->Flags &= ~VPB_MOUNTED;
-        } else
+        vde = Vcb->vde;
+        vde->mounted_device = NULL;
+        Vcb->removing = TRUE;
+        Vcb->Vpb->Flags &= ~VPB_MOUNTED;
+        Vcb->Vpb->Flags |= VPB_DIRECT_WRITES_ALLOWED;
+        
+        if (Vcb->open_files == 0)
             uninit(Vcb, FALSE);
     }
 
@@ -248,22 +250,21 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS pnp_start_device(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
-    FIXME("STUB\n");
-
-    return STATUS_NOT_IMPLEMENTED;
-}
-
-static NTSTATUS pnp_surprise_removal(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
+NTSTATUS pnp_surprise_removal(PDEVICE_OBJECT DeviceObject, PIRP Irp) {
     device_extension* Vcb = DeviceObject->DeviceExtension;
     
     TRACE("(%p, %p)\n", DeviceObject, Irp);
     
     if (DeviceObject->Vpb->Flags & VPB_MOUNTED) {
-        if (Vcb->open_files > 0) {
-            Vcb->removing = TRUE;
-            Vcb->Vpb->Flags &= ~VPB_MOUNTED;
-        } else
+        volume_device_extension* vde;
+        
+        vde = Vcb->vde;
+        vde->mounted_device = NULL;
+        Vcb->removing = TRUE;
+        Vcb->Vpb->Flags &= ~VPB_MOUNTED;
+        Vcb->Vpb->Flags |= VPB_DIRECT_WRITES_ALLOWED;
+        
+        if (Vcb->open_files == 0)
             uninit(Vcb, FALSE);
     }
 
@@ -280,8 +281,13 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        volume_device_extension* vde = DeviceObject->DeviceExtension;
+        IoSkipCurrentIrpStackLocation(Irp);
+        Status = IoCallDriver(vde->pdo, Irp);
+        goto exit;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
     
@@ -289,7 +295,7 @@
     
     switch (IrpSp->MinorFunction) {
         case IRP_MN_CANCEL_REMOVE_DEVICE:
-            Status = pnp_cancel_remove_device(DeviceObject, Irp);
+            Status = pnp_cancel_remove_device(DeviceObject);
             break;
 
         case IRP_MN_QUERY_REMOVE_DEVICE:
@@ -297,13 +303,9 @@
             break;
 
         case IRP_MN_REMOVE_DEVICE:
-            Status = pnp_remove_device(DeviceObject, Irp);
+            Status = pnp_remove_device(DeviceObject);
             break;
 
-        case IRP_MN_START_DEVICE:
-            Status = pnp_start_device(DeviceObject, Irp);
-            break;
-
         case IRP_MN_SURPRISE_REMOVAL:
             Status = pnp_surprise_removal(DeviceObject, Irp);
             break;
@@ -313,7 +315,7 @@
             
             IoSkipCurrentIrpStackLocation(Irp);
             Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
-            goto end;
+            goto exit;
     }
 
 // //     Irp->IoStatus.Status = Status;
@@ -325,11 +327,12 @@
 // 
 // //     IoCompleteRequest(Irp, IO_NO_INCREMENT);
 
+end:
     Irp->IoStatus.Status = Status;
 
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
     
-end:
+exit:
     if (top_level) 
         IoSetTopLevelIrp(NULL);
     
Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 74430)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -20,11 +20,9 @@
 enum read_data_status {
     ReadDataStatus_Pending,
     ReadDataStatus_Success,
-    ReadDataStatus_Cancelling,
-    ReadDataStatus_Cancelled,
     ReadDataStatus_Error,
-    ReadDataStatus_CRCError,
-    ReadDataStatus_MissingDevice
+    ReadDataStatus_MissingDevice,
+    ReadDataStatus_Skip
 };
 
 struct read_data_context;
@@ -37,6 +35,10 @@
     PIRP Irp;
     IO_STATUS_BLOCK iosb;
     enum read_data_status status;
+    BOOL not_alloc;
+    PMDL mdl;
+    UINT64 stripestart;
+    UINT64 stripeend;
 } read_data_stripe;
 
 typedef struct {
